## wolf-spectrum-1.0.0-3.src.tar.gz

=== Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#
# Modified by Patrick Desaulniers
#

include Makefile.mk

all: libs plugins gen

# --------------------------------------------------------------

PREFIX  ?= /usr/local
DESTDIR ?=

define MISSING_SUBMODULES_ERROR

Cannot find DGL! Please run "make submodules" to clone the missing submodules, then retry building the plugin.

endef

# --------------------------------------------------------------

submodules: 
	git submodule update --init --recursive

libs:
ifeq (,$(wildcard dpf/dgl))
	$(error $(MISSING_SUBMODULES_ERROR))
endif

ifeq ($(HAVE_DGL),true)
	$(MAKE) -C dpf/dgl
endif

plugins: libs
	$(MAKE) all -C plugins/wolf-spectrum

gen: plugins dpf/utils/lv2_ttl_generator
	"$(CURDIR)/dpf/utils/generate-ttl.sh"
ifeq ($(MACOS),true)
	"$(CURDIR)/dpf/utils/generate-vst-bundles.sh"
endif

dpf/utils/lv2_ttl_generator:
	$(MAKE) -C dpf/utils/lv2-ttl-generator

# --------------------------------------------------------------

clean:
ifeq ($(HAVE_DGL),true)
	$(MAKE) clean -C dpf/dgl
endif
	$(MAKE) clean -C dpf/utils/lv2-ttl-generator
	$(MAKE) clean -C plugins/wolf-spectrum
	rm -rf bin/*

# --------------------------------------------------------------

install:
	install -d $(DESTDIR)$(PREFIX)/lib/lv2/
	install -d $(DESTDIR)$(PREFIX)/lib/vst/
	install -d $(DESTDIR)$(PREFIX)/bin/

	cp bin/*-vst.*    $(DESTDIR)$(PREFIX)/lib/vst/
	cp -r bin/*.lv2   $(DESTDIR)$(PREFIX)/lib/lv2/
	cp bin/wolf-spectrum $(DESTDIR)$(PREFIX)/bin/

# --------------------------------------------------------------

.PHONY: plugins

=== dpf/dgl/Makefile ===
#!/usr/bin/make -f
# Makefile for dgl #
# ---------------- #
# Created by falkTX
#

include Makefile.mk

# --------------------------------------------------------------

BUILD_C_FLAGS   += $(DGL_FLAGS) -I. -Isrc -DDGL_NAMESPACE=$(DGL_NAMESPACE)
BUILD_CXX_FLAGS += $(DGL_FLAGS) -I. -Isrc -DDGL_NAMESPACE=$(DGL_NAMESPACE)

ifeq ($(FONS_USE_FREETYPE),true)
BUILD_C_FLAGS   += -DFONS_USE_FREETYPE=$(FONS_USE_FREETYPE)
BUILD_CXX_FLAGS += -DFONS_USE_FREETYPE=$(FONS_USE_FREETYPE)
endif

LINK_FLAGS      += $(DGL_LIBS)

ifneq ($(MACOS_OLD),true)
# needed by sofd right now, fix later
BUILD_CXX_FLAGS += -Wno-type-limits -fpermissive
endif

# --------------------------------------------------------------

OBJS = \
	src/Application.cpp.o \
	src/Color.cpp.o \
	src/Geometry.cpp.o \
	src/Image.cpp.o \
	src/ImageWidgets.cpp.o \
	src/NanoVG.cpp.o \
	src/Resources.cpp.o \
	src/Widget.cpp.o

ifeq ($(MACOS),true)
OBJS += src/Window.mm.o
else
OBJS += src/Window.cpp.o
endif

TARGET = ../libdgl.a

# --------------------------------------------------------------

all: $(TARGET)

# --------------------------------------------------------------

../libdgl.a: $(OBJS)
	rm -f $@
	$(AR) crs $@ $^

../libdgl.dll: $(OBJS)
	# -Wl,--output-def,$@.def,--out-implib,$@.a
	$(CXX) $^ -shared $(LINK_FLAGS) -o $@

../libdgl.dylib: $(OBJS)
	$(CXX) $^ -dynamiclib $(LINK_FLAGS) -o $@

../libdgl.so: $(OBJS)
	$(CXX) $^ -shared $(LINK_FLAGS) -o $@

# --------------------------------------------------------------

%.c.o: %.c
	$(CC) $< $(BUILD_C_FLAGS) -c -o $@

%.cpp.o: %.cpp
	$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

src/Window.cpp.o: src/Window.cpp src/pugl/*
	$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

src/Window.mm.o: src/Window.cpp src/pugl/*
	$(CXX) $< $(BUILD_CXX_FLAGS) -ObjC++ -c -o $@

# --------------------------------------------------------------

clean:
	rm -f src/*.d src/*.o ../libdgl.*

debug:
	$(MAKE) DEBUG=true

# --------------------------------------------------------------

-include $(OBJS:%.o=%.d)

# --------------------------------------------------------------

=== plugins/wolf-spectrum/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#
# Modified by Patrick Desaulniers
#
# --------------------------------------------------------------
# Project name, used for binaries
#
# Set PLUGIN_NAME in Makefile.mk at the project's root directory
#

NAME = $(PLUGIN_NAME)

# --------------------------------------------------------------
# Files to build

OBJS_DSP = \
	Libs/varchunk/varchunk.c.o \
	Common/Utils/src/Mathf.cpp.o \
	WolfSpectrumPlugin.cpp.o

OBJS_UI  = \
	Libs/varchunk/varchunk.c.o \
	Common/Utils/src/Mathf.cpp.o \
	Common/Structures/src/Margin.cpp.o \
	Common/Structures/src/Animation.cpp.o \
	Config/src/Config.cpp.o \
	Libs/inih/ini.c.o \
	Libs/inih/INIReader.cpp.o \
	Resources/Fonts/chivo_bold.cpp.o \
	Resources/Fonts/chivo_italic.cpp.o \
	Common/Widgets/src/NanoLabel.cpp.o \
	Common/Widgets/src/ResizeHandle.cpp.o \
	Common/Widgets/src/RightClickMenu.cpp.o \
	ScrollingTexture.cpp.o \
	Spectrogram.cpp.o \
	Libs/kissfft/kiss_fft.cpp.o \
	Common/Structures/src/ParamSmooth.cpp.o \
	Common/Structures/src/PeakFallSmooth.cpp.o \
	WolfSpectrumUI.cpp.o 

# --------------------------------------------------------------
# Plugins types to build

BUILD_LV2 ?= true
BUILD_VST2 ?= true
BUILD_JACK ?= true
BUILD_DSSI ?= false
BUILD_LADSPA ?= false

# --------------------------------------------------------------
# Do some magic

include ../Makefile.mk

# --------------------------------------------------------------
# Additional flags

ifeq ($(PARANOID_MODE),true)
BASE_FLAGS += -Wall -Wextra -Werror
endif

# --------------------------------------------------------------
# Enable all possible plugin types

ifeq ($(BUILD_JACK),true)
ifeq ($(HAVE_JACK),true)
TARGETS += jack
endif
endif

ifeq ($(BUILD_LADSPA),true)
TARGETS += ladspa
endif

ifeq ($(BUILD_DSSI),true)
ifeq ($(HAVE_DGL),true)
ifeq ($(HAVE_LIBLO),true)
TARGETS += dssi
endif
endif
endif

ifeq ($(BUILD_LV2),true)
TARGETS += lv2
endif

ifeq ($(BUILD_VST2),true)
TARGETS += vst
endif

all: $(TARGETS)

# --------------------------------------------------------------

=== plugins/wolf-spectrum/Common/Structures/test/Makefile ===
CC=g++
binaries=Main.o TestGraph.o TestStack.o Graph.o

all: Graph.o tests

Graph.o: ../src/Graph.cpp
	$(CC) -c ../src/Graph.cpp -I../ -o Graph.o
	
tests: $(binaries)
	$(CC) -o tests $(binaries) $(INC) -lboost_unit_test_framework

clean:
	rm -f $(binaries) tests

=== plugins/wolf-spectrum/Common/Utils/Fonts/Makefile ===
CC=g++
FILE=getchunk

ttf2cpp: $(FILE).cpp
	 $(CC) $(FILE).cpp -I../../../../../dpf/distrho/extra -o $(FILE)

clean:
	rm -f $(FILE)

=== pkg/debian/changelog ===
wolf-spectrum (0.1.1-1) stretch; urgency=medium

  * Initial build.

 -- Patrick Desaulniers <desaulniers.patrick@carrefour.cegepvicto.ca>  Fri, 25 Jan 2018 21:12:30 -0400

=== PKGBUILD ===
# Maintainer: David Runge <dave@sleepmap.de>

pkgname=wolf-spectrum
pkgver=1.0.0
pkgrel=3
pkgdesc="A spectrogram plugin"
arch=('x86_64')
url="https://github.com/pdesaulniers/wolf-spectrum"
license=('GPL3')
groups=('lv2-plugins' 'pro-audio' 'vst-plugins')
depends=('jack' 'libglvnd')
makedepends=('gendesk' 'lv2')
source=("https://github.com/pdesaulniers/${pkgname}/releases/download/v${pkgver}/${pkgname}-v${pkgver}-source.tar.gz")
sha512sums=('e84abfef3a08d8da8fe5350088f43d7670c5ff828ec7bf7ddcd4b3c19c1cdba6560be7b69ab5b9af1d27c80c195f123e635d2337e0a297282564935d54b8d501')

prepare() {
  mv -v "$pkgname" "$pkgname-$pkgver"
  cd "$pkgname-$pkgver"
  # XDG desktop file
  gendesk -n \
          --pkgname ${pkgname} \
          --pkgdesc "${pkgdesc}" \
          --categories "AudioVideo;Audio"
}

build() {
  cd "$pkgname-$pkgver"
  BUILD_VST2=true BUILD_LV2=true BUILD_JACK=true make
}

package() {
  cd "$pkgname-$pkgver"
  install -vDm 755 "bin/${pkgname}" -t "${pkgdir}/usr/bin/"
  install -vDm 644 "${pkgname}.desktop" \
    -t "${pkgdir}/usr/share/applications"
  install -vDm 755 "bin/${pkgname}-vst.so" -t "${pkgdir}/usr/lib/vst"
  install -vDm 755 "bin/${pkgname}.lv2/"*.so \
    -t "${pkgdir}/usr/lib/lv2/${pkgname}.lv2"
  install -vDm 644 "bin/${pkgname}.lv2/"*.ttl \
    -t "${pkgdir}/usr/lib/lv2/${pkgname}.lv2"
  install -vDm 644 README.md -t "${pkgdir}/usr/share/doc/${pkgname}"
}

=== pkg/debian/control ===
Source: wolf-spectrum
Section: sound
Priority: optional
Maintainer: Patrick Desaulniers <desaulniers.patrick@carrefour.cegepvicto.ca>
Uploaders:
 Patrick Desaulniers <desaulniers.patrick@carrefour.cegepvicto.ca>
Build-Depends:
 debhelper (>= 9),
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjack-jackd2-dev | libjack-dev,
 libx11-dev,
 libxext-dev,
 lv2-dev,
 pkg-config,
Standards-Version: 3.9.8
Homepage: https://github.com/pdesaulniers/wolf-spectrum

Package: wolf-spectrum
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Provides:
 lv2-plugins,
 vst-plugins,
Description: Wolf Spectrum plugin
 Wolf Spectrum is a free, cross-platform spectrogram plugin.
 .
 Wolf Spectrum is using the DPF framework and is available as LV2, VST, and
 standalone JACK-application.

=== pkg/debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ 

override_dh_auto_build:
	BUILD_VST2=true BUILD_LV2=true BUILD_JACK=true make

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

=== pkg/debian/watch ===
version=3
opts=filenamemangle=s/.+\/release-?(\d\S*)\.tar\.gz/wolf-spectrum-$1\.tar\.gz/ \
  https://github.com/pdesaulniers/wolf-spectrum/tags .*/release-?(\d\S*)\.tar\.gz
